#include <stdio.h>
#include <string.h>

#include "common.h"
#include "extern.h"
#include "gmpv4sp.h"
#include "rxl.h"

int _asm_load();

void usage( void )
{
	printf( "Usage: RXL /LOAD (2608/2203/BEEP.BIN)\n" );
	printf( "       RXL /RELEASE\n" );
}

int main( int ac, char **av )
{
	printf( "Falcom BEEP/2608/2203.BIN Loader 100621 (c)KUROHANE Works\n" );
	printf( "\n" );

	if( ac < 2 )
	{
		usage();
		return 0;
	}

	if( GMPV4SP_check() != 0 ) return -1;

	if( strcmpi( av[1], OPT[OPT_LOAD] ) == 0 )
	{
		if( load( av[2] ) != 0 ) return 1;
	}

	if( strcmpi( av[1], OPT[OPT_RELEASE] ) == 0 )
	{
		if( release() != 0 ) return 1;
	}

	printf( "\n" );

	return 0;
}

int load( char *filename )
{
	unsigned short	seg;
	unsigned short	off;

	if( GMPV4SP_size( 0 ) == -1 ) return 1;

	GMPV4SP_address( &seg, &off, 0 );

	if( GMPV4SP_load( filename, 0x00000000, 0, 1 ) == -1 ) return 1;

	_asm_load( "\
			mov		[load_adr+2],dx\n \
			mov		dx,0x188\n \
			callf	[load_adr]\n \
		load_adr:	dw 0, 0\n \
		",
		_asm_load,
		_asm_load,
		_asm_load,
		seg
	);

	return 0;
}

int release( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x42, 1, -8, id );

	if( memcmp( id, "gmpv4sp ", 7 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], "RX" );
		return 1;
	}

	/* Stop */
	r.h.ah = 0x01;
	int86x( 0x42, &r, &ro, &sr );

	/* Release */
	r.h.ah = 0x07;
	int86x( 0x42, &r, &ro, &sr );

	return 0;
}
